
#ifndef _AI_SWARM_H
#define _AI_SWARM_H

#include "world_entity.h"
#include "ai_module.h"



class AISwarm{
	public:
		AISwarm();
		~AISwarm(){}
		void process(float dt);
		void addAI(WorldEntity*);
		void removeAI(WorldEntity*);

		inline int getSwarmSize(){return members.size();}
		inline void setDestination(Vector destination){this->destination=destination;}
		inline void setTarget(WorldEntity* target){this->target=target;}
		Vector getPosition();

		enum statusType{ATTACKING,MOVING,WAITING};

	private:
		float getRadius(WorldEntity* object);


		Vector destination;
		Vector movement;
		WorldEntity* target;
		statusType status;

		std::map<WorldEntity*,AIModule*> members;

		int tickCount;
		int randomFreq;
		Vector randomVector;
};

#endif /* _AI_SWARM_H */
